#include <glm/glm.hpp>
#include <glm/ext/matrix_transform.hpp>

class Camera
{
	public:
		Camera() = default;
		virtual ~Camera()
		{
		}

		const glm::mat4& get_view();
		const glm::mat4& get_projection();

	protected:
	    const glm::mat4& matrix;
		glm::mat4 m_view, m_projection;
};

